#include "gcc-plugin.h"
#include "md5.h"

int plugin_is_GPL_compatible;

int
plugin_init (struct plugin_name_args* plugin_info,
	     struct plugin_gcc_version* gcc_version) 
{
  struct md5_ctx ctx;
  char md5hex[32];
  char buffer[80] = "Here is the buffer and I want to get the md5 of this string";

  memset (&ctx, 0, sizeof(ctx));
  gcc_assert (plugin_info != NULL);
  if (!plugin_default_version_check (version, &gcc_version))
    return 1;
  //compute md5
  md5_init_ctx (&ctx);
  md5_process_bytes (buffer , sizeof(char)*80), &ctx);
  md5_finish_ctx (&ctx, md5srctab);
  //print it as hex
  memset (md5hex, 0, sizeof(md5hex));
  for (ix=0; ix<16; ix++) {
    char hexb[4] = {0,0,0,0};
    int curbyt = md5srctab[ix] & 0xff;
    snprintf (hexb, sizeof(hexb)-1, "%02x", curbyt);
    md5hex[2*ix] = hexb[0];
    md5hex[2*ix+1] = hexb[1];
  }
  printf("md5: %s \n", md5hex);
  return 0;
}
